//------------------------------------------------------------------------------
process Barra_Deslizante(int iX, int iAncho, int iY, int iAlto, int iAlto_Boton, dword dColor_Boton,
			  dword dColor_Simbolo_Boton, dword dColor_Barra, dword dColor_Boton_Barra,
			  int iValor_Maximo, int iValor_Inicial, int iDrawingZ, int iTextZ)

/*
Funcin que dibuja una barra deslizante.

iX: 	Coordenada X.
iAncho:	Ancho de la barra. 0-Por defecto.
iY:		Coordenada Y.
iAlto:	Alto de la barra incluido los botones. 0-Por defecto.
iAlto_Boton: 	Alto del botn de la barra. Ancho de la bara por defecto. 
dColor_Boton:	Color del botn. 0-Gris por defecto.
dColor_Simbolo_Boton: 	0-Negro por defecto.
dColor_Barra: 			Color de la barra. 0-Gris Claro por defecto.
dColor_Boton_Barra: 	Color del boton que se desliza sobre la barra. 0-Gris Oscuro por defecto.
iValor_Maximo:	Valor mximo de la Barra.
iValor_Inicial:	Valor inicial.
iValor			Valor actual.
*/




private
	byte bContador=0;  // Contador de usos mltiples.
	int iMouse_Diferencia=0;
	int iMouse_Inicio=0;

	string sTexto[0]="";
	int iTamano_Barra=0;
	int iTamano_Barra_Libre=0;
	int iAlto_Boton_Central=0;
	int iValor_Antiguo=0;
	int iIde[70]=0;
	Boton iIde_Arriba;
	Boton iIde_Abajo;
	Boton iIde_Centro;
end

begin
	load_fpg("cursors.fpg");
	drawing_z(iDrawingZ);  // Coordenadas de dibujo muy altas para asegurarnos que se ve el botn.
	// Inicializando varables por defecto.
	bRepintar=0;
	if (iAncho==0)
		iAncho=20;
	end
	if (iAlto==0)
		iAlto=300;
	end
	if (iAlto_Boton==0)
		iAlto_Boton=iAncho;
	end
	if (dColor_Boton==0)
		dColor_Boton=rgb(190,190,190);
	end
	if (dColor_Simbolo_Boton==0)
		dColor_Simbolo_Boton=rgb(0,0,0);
	end
	if (dColor_Barra==0)
		dColor_Barra=rgb(200,200,200);
	end
	if (dColor_Boton_Barra==0)
		dColor_Boton_Barra=rgb(190,190,190);
	end
	//Calculo el tamaa de la barra descontandole los 3 botones.
	iTamano_Barra=iAlto-iAlto_Boton*3;
	
	iAlto_Boton_Central=iAlto_Boton;
	// Si el tamao de la barra es mayor que el valor a mximo, aumento el boton central para igualar dicho tamao.
	if(iTamano_Barra>iValor_Maximo);
		iAlto_Boton_Central=iAlto_Boton+iTamano_Barra-iValor_Maximo;
	end
	iValor=iValor_Inicial;
	iTamano_Barra_Libre=iAlto-iAlto_Boton*2-iAlto_Boton_Central;
	
	//Dibujo los botones arriba, abajo y centro.
	iIde_Arriba=boton(iAncho, iAlto_Boton, &sTexto, 1, 0, 4, dColor_Boton, 0, 0, 10, iDrawingZ, iTextZ);
	iIde_Arriba.iX=iX;
	iIde_Arriba.iY=iY;
	iIde_Arriba.bRepintar=1;
	iIde_Abajo=boton(iAncho, iAlto_Boton, &sTexto, 1, 0, 4, dColor_Boton, 0, 0, 9, iDrawingZ, iTextZ);
	iIde_Abajo.iX=iX;
	iIde_Abajo.iY=iY+iAlto-iAlto_Boton;
	iIde_Abajo.bRepintar=1;
	iIde_Centro=boton(iAncho, iAlto_Boton_Central, &sTexto, 1, 0, 4, dColor_Boton, 0, 0, 0, iDrawingZ-1, iTextZ);
	iIde_Centro.iX=iX;
	iIde_Centro.iY=iY+iAlto_Boton;
	iIde_Centro.bRepintar=1;
	drawing_z(iDrawingZ);  // Coordenadas de dibujo muy altas para asegurarnos que se ve el botn.
	//Dibujo barra por donde se desplaza el botn central.
	drawing_color(rgb(50,50,50));
	iIde[0]=draw_line(iX,iY+iAlto-iAlto_Boton-1,iX+iAncho-1,iY+iAlto-iAlto_Boton-1);
	iIde[1]=draw_line(iX+iAncho-1,iY+iAlto_Boton,iX+iAncho-1,iY+iAlto-iAlto_Boton);
	drawing_color(rgb(255,255,255));
	iIde[2]=draw_line(iX,iY+iAlto_Boton,iX+iAncho-1,iY+iAlto_Boton);
	iIde[3]=draw_line(iX,iY+iAlto_Boton,iX,iY+iAlto-iAlto_Boton);
	drawing_color(rgb(200,200,200));
	iIde[4]=draw_box(iX,iY+iAlto_Boton,iX+iAncho-1,iY+iAlto-iAlto_Boton-2);
	//Ajust boton central al valor inicial.
	if (iValor_Maximo!=0)
		iIde_Centro.iY=(iValor*iTamao_Barra_Libre)/iValor_Maximo-(-1-iY-iAlto_Boton)-1;
	else
		iIde_Centro.iY=-(-1-iY-iAlto_Boton)-1;
	end
	iIde_Centro.bRepintar=1;
	iValor_Antiguo=iValor;
	loop
	
		if (iIde_Arriba.bPulsado==1) 	// Si pulso del botn de abajo, incremento 1 el valor de la barra.
			if(iValor>0);				// Tengo en cuenta la repeticin de teclas.
				iValor--;
				// Si el valor es multiplo de la barra, muevo el botn central.
				if (((iIde_Centro.iY-iY-iAlto_Boton)*iValor_Maximo/iTamao_Barra_Libre)>=iValor)
					iIde_Centro.iY--;
					iIde_Centro.bRepintar=1;
				end
			end
			frame;
			timer[0]=0;
			while (timer[0]<40)
				frame; 
				if (!iIde_Arriba.bPulsado==1)
					timer[0]=50;
				end
			end
			while (iIde_Arriba.bPulsado==1)
				if(iValor>0);
					iValor--;
					if (((iIde_Centro.iY-iY-iAlto_Boton)*iValor_Maximo/iTamao_Barra_Libre)>=iValor)
						iIde_Centro.iY--;
						iIde_Centro.bRepintar=1;
					end
				end
				frame;
			end
			frame;
		end
		if (iIde_Abajo.bPulsado==1) // Si pulso del botn de abajo, incremento 1 el botn central.
			if(iValor<iValor_Maximo);
				iValor++;
				if (((iIde_Centro.iY-iY-iAlto_Boton)*iValor_Maximo/iTamao_Barra_Libre)<=iValor)
					iIde_Centro.iY++;
					iIde_Centro.bRepintar=1;
				end
			end
			frame;
			timer[0]=0;
			while (timer[0]<40)
				frame; 
				if (!iIde_Abajo.bPulsado==1)
					timer[0]=50;
				end
			end
			while (iIde_Abajo.bPulsado==1)
			if(iValor<iValor_Maximo);
				iValor++;
				if (((iIde_Centro.iY-iY-iAlto_Boton)*iValor_Maximo/iTamao_Barra_Libre)<=iValor)
					iIde_Centro.iY++;
					iIde_Centro.bRepintar=1;
				end
			end
				frame;
			end
			frame;
		end

		if (iIde_Centro.bPulsado==1 and iMouse_Diferencia==0)  // Si pulsal el botn central calculo la distancia entre este y el mouse.
			iMouse_Diferencia=mouse.y-iIde_Centro.iY;
			iMouse_Inicio=mouse.y;
		end
		if (iIde_Centro.bPulsado==1 and iMouse_Diferencia!=0 and iMouse_Inicio!=mouse.y)  // Si se muevo el mouse, muevo el botn central.
			iMouse_Inicio=0;
			iIde_Centro.iY=mouse.y-iMouse_Diferencia;
			if (iValor_Maximo==(iAlto-iAlto_Boton*2-iAlto_Boton_Central-3))
				iValor=iIde_Centro.iY-iY-iAlto_Boton-1;
			else
				if (iTamao_Barra_Libre!=0)
					iValor=(iIde_Centro.iY-iY-iAlto_Boton)*iValor_Maximo/iTamao_Barra_Libre;
				else
					iValor=0;
				end
			end
			iIde_Centro.bRepintar=1;
		end
		if (iIde_Centro.bPulsado==0)  // Si sueltan el mouse, borro la distancia entre el botn central y el mouse.
			iMouse_Diferencia=0;
		end

		if (iValor_Antiguo!=iValor)
			iIde_Centro.bRepintar=1;
			iValor_Antiguo=iValor;
		end

		// Comprobando el salto de pgina.
		// Pulso por arriba.
		if (mouse.x>iX and mouse.x<iX+iAncho and
			(mouse.y>iY+iAlto_Boton and mouse.y<iIde_Centro.iY)
			and mouse.left and iIde_Centro.bPulsado==0)
			iValor=iValor-iSalto;
			if (iValor<0)
				iValor=0;
			end
			if (iValor_Maximo!=0)
				iIde_Centro.iY=(iValor*iTamao_Barra_Libre)/iValor_Maximo-(-1-iY-iAlto_Boton)-1;
			else
				iIde_Centro.iY=-(-1-iY-iAlto_Boton)-1;
			end
			iIde_Centro.bRepintar=1;
			frame;
			timer[0]=0;
			while (timer[0]<40)
				frame; 
				if (!mouse.left)
					timer[0]=50;
				end
			end
			while (mouse.left)
				iValor=iValor-iSalto;
				if (iValor<0)
					iValor=0;
				end
				if (iValor_Maximo!=0)
					iIde_Centro.iY=(iValor*iTamao_Barra_Libre)/iValor_Maximo-(-1-iY-iAlto_Boton)-1;
				else
					iIde_Centro.iY=-(-1-iY-iAlto_Boton)-1;
				end
				iIde_Centro.bRepintar=1;
				frame;
			end
		end
		// Pulso por abajo.
		if (mouse.x>iX and mouse.x<iX+iAncho and
			(mouse.y<iY+iAlto-iAlto_Boton-1 and mouse.y>iIde_Centro.iY+iAlto_Boton_Central)
			and mouse.left and iIde_Centro.bPulsado==0)
			iValor=iValor+iSalto;
			if (iValor>iValor_Maximo)
				iValor=iValor_Maximo;
			end
			if (iValor_Maximo!=0)
				iIde_Centro.iY=(iValor*iTamao_Barra_Libre)/iValor_Maximo-(-1-iY-iAlto_Boton)-1;
			else
				iIde_Centro.iY=-(-1-iY-iAlto_Boton)-1;
			end
			iIde_Centro.bRepintar=1;
			frame;
			timer[0]=0;
			while (timer[0]<40)
				frame; 
				if (!mouse.left)
					timer[0]=50;
				end
			end
			while (mouse.left)
				iValor=iValor+iSalto;
				if (iValor>iValor_Maximo)
					iValor=iValor_Maximo;
				end
				iIde_Centro.iY=(iValor*iTamao_Barra_Libre)/iValor_Maximo-(-1-iY-iAlto_Boton)-1;
				iIde_Centro.bRepintar=1;
				frame;
			end
		end

		if (iIde_Centro.iY<iY+iAlto_Boton)  // Compruebo que el boton central no se sale fuera de rango.
			iIde_Centro.iY=iY+iAlto_Boton;
			iValor=0;
		end
		if (iIde_Centro.iY>iIDe_Abajo.iY-iAlto_Boton_Central)  // Compruebo que el boton central no se sale fuera de rango.
			iIde_Centro.iY=iIDe_Abajo.iY-iAlto_Boton_Central;
			iValor=iValor_Maximo;
		end

		if (bRepintar==1)
			bRepintar=0;
			if (iValor_Maximo!=0)
				iIde_Centro.iY=(iValor*iTamao_Barra_Libre)/iValor_Maximo-(-1-iY-iAlto_Boton)-1;
			else
				iIde_Centro.iY=-(-1-iY-iAlto_Boton)-1;
			end
			iIde_Centro.bRepintar=1;
		end
	frame;
	end
OnExit
		bContador=0;
		while (bContador<=4)
			delete_draw(iIde[bContador]);
			bContador++;
		end
	if (exists (iIde_Arriba))
		signal(iIde_Arriba,s_Kill_tree);
	end
	if (exists (iIde_Abajo))
		signal(iIde_Abajo,s_Kill_tree);
	end
	if (exists (iIde_Centro))
		signal(iIde_Centro,s_Kill_tree);
	end
		frame;
end
//------------------------------------------------------------------------------

